<%@ control language="C#" autoeventwireup="true" inherits="EMR.AwivComp, EMR_deploy" %>
<%@ Register Src="AwivMissingComp.ascx" TagName="AwivMissingComp" TagPrefix="uc1" %>
<%@ Import Namespace="EXT.DOMAIN.mdo"%>
<%@ Import Namespace="EXT.DOMAIN.hds.text" %>
<script for="AWIVControl" event="OnGeneralError" type="text/javascript">
	alert("General Error");
</script>
	
<script for="AWIVControl" event="OnDecryptError" type="text/javascript">
  	alert("Decryption Error");
</script>
	
<script for="AWIVControl" event="OnParamsError" type="text/javascript">
  	alert("Params Error");
</script>

<object id="AWIVControl" 
		classid="<%=AwivClassId%>" 
		type="application/x-oleobject"
		width="100%" 
		height="100%" 
		name="AWIVControl">
	<uc1:AwivMissingComp ID="awivMissingComp" runat="server" />
	<param name='VW_ParmStr' value='<%=getParamString()%>' />
</object>

<script runat="server">
	
	protected virtual string getPatientName() {
		if (_patientNameFormat == null) {
			return _patientState.Patient.PrimaryName.ToString();
		}
		else {
			return _patientNameFormat.formatText(_patientState.Patient.PrimaryName);
		}
	}

	protected virtual string getPatientNationalId() {
		if (_nationalIdFormat == null) {
			return _patientState.Patient.NationalId.RawNationalId;
		}
		else {
			return _nationalIdFormat.formatText(_patientState.Patient.NationalId);
		}
	}

	protected virtual string getPatientFullIcn() {
		return _patientState.Patient.FullIcn;
	}

	protected virtual string getProgressNoteReportId() {
		return "RPT^CPRS;" + _user.Domain + "^" + getPatientId(_report.SiteId) + "^TIU^" + _report.Id + "^^^^^^^^0";
	}

	protected virtual string getImagingReportId() {
		return "RPT^CPRS;" + _user.Domain + "^" + getPatientId(_report.SiteId) + "^RA^i" + _report.Id + "^" + ((IImagingReport)_report).CaseNum + "^^^^^^^1";
	}

	protected override string getReportId() {
		string propName = Request.QueryString[EXT.DOMAIN.vistaweb.ui.UiConstants.PROPERTY];
		if (propName == null) {
			logger.Error("null property name");
			return "NULL_PROPERTY_NAME";
		}
		if (StringUtils.equalsNullSafeIgnoreCase(propName, "ProgressNotes")) {
			return getProgressNoteReportId();
		}
		else if (StringUtils.equalsNullSafeIgnoreCase(propName, "imagingReports")) {
			return getImagingReportId();
		}
		else {
			logger.Error("invalid property name:" + propName);
			return "INVALID_PROPERTY_NAME";
		}
	}

	protected virtual string getPatientId(string siteId) {
		if (siteId == null || siteId.Length<1) {
			return "ERROR_NO_SITE_ID";
		}
		string anId = _patientState.Patient.getIdForSite(siteId);
		if (anId == null || anId.Length<1) {
			anId = "ERROR_NO_PT_ID";
		}
		return anId;
	}

	protected virtual string getPatientSiteId() {
		return _report.SiteId;
	}

	protected virtual string getUserName() {
		if (_userNameFormat == null) {
			return _user.PrimaryName.ToString();
		}
		else {
			return _userNameFormat.formatText(_user.PrimaryName);
		}
	}

	protected virtual string getUserId() {
		return _user.PrimarySiteId.Id;
	}

	protected virtual string getUserNationalId() {
		if (_nationalIdFormat == null) {
			return _user.NationalId.RawNationalId;
		}
		else {
			return _nationalIdFormat.formatText(_user.NationalId);
		}
	}

	protected virtual string getUserSiteName() {
		return _user.Site.Name;
	}

	protected virtual string getUserSiteId() {
		return _user.PrimarySiteId.SiteId;
	}

	protected virtual string getRequestTokenViaVista() {
		EXT.DOMAIN.mdo.dao.vista.IVistaDataSourceDao aDao = (EXT.DOMAIN.mdo.dao.vista.IVistaDataSourceDao)_multiDao.getDAO(_user.Site.Id);
		string tokenString = null;
		if (aDao != null) {
			tokenString = aDao.getBseToken();
		}
		else {
			tokenString = "NO_DAO_FOUND_FOR_SITE_" + _user.Site.Id;
		}
		return _securityPhrase + "^" + tokenString;
	}

	protected virtual string getRequestTokenViaSession() {
		string aToken = "";
		if (_user == null) {
			aToken = "USER_NULL";
		}
		else {
			aToken = EXT.DOMAIN.vistaweb.ui.UiUserUtils.getSessionIdFromPrincipal(_user);
			if (aToken == null) {
				aToken = "USER_TOKEN_NOT_FOUND";
			}
		}
		return _securityPhrase + "^" + aToken;
	}

	protected virtual string getRequestId() {
		return "2001";
	}

	protected virtual string getImagingSiteServiceUrl() {
		if (_siteTableDao == null) {
			return "NO_SITE_TABLE_DAO";
		}
		string siteId = "ISITESRV";
		EXT.DOMAIN.mdo.site.ISite aSite = _siteTableDao.getSiteTable().getSite(siteId);
		if (aSite == null) {
			return "NO_SITE_FOUND_" + siteId;
		}
		EXT.DOMAIN.mdo.IDataSource[] dataSources = aSite.getDataSourceByProtocol("REF");
		if (dataSources == null || dataSources.Length < 1) {
			return "NO_REF_DATA_SOURCE";
		}
		return dataSources[0].Source;
	}

	protected virtual string getRequestSource() {
		return "VW";
	}

	protected virtual string getParamString() {
		StringBuilder str = new StringBuilder();
		str.Append("&A{");
		str.Append(getPatientName());
		str.Append("}&B{");
		str.Append(getPatientNationalId());
		str.Append("}&C{");
		str.Append(getPatientFullIcn());
		str.Append("}&D{");
		str.Append(getReportId());
		str.Append("}&E{");
		str.Append(getPatientSiteId());
		str.Append("}&F{");
		str.Append(getUserName());
		str.Append("}&G{");
		str.Append(getUserId());
		str.Append("}&H{");
		str.Append(getUserNationalId());
		str.Append("}&I{");
		str.Append(getUserSiteName());
		str.Append("}&J{");
		str.Append(getUserSiteId());
		str.Append("}&K{");
		str.Append(getRequestTokenViaSession());
		str.Append("}&L{");
		str.Append(getImagingSiteServiceUrl());
		str.Append("}&M{");
		str.Append(getRequestId());
		str.Append("}&O{");
		str.Append(getRequestSource());
		str.Append("}");
		string theParam = str.ToString();
		if (logger.IsDebugEnabled) {
			logger.Debug(theParam);
		}
		if (Trace.IsEnabled) {
			Trace.Write(theParam);
		}
		maybeAuditAccess();
		if (_cryptoProvider == null) {
			return theParam;
		}
		return _cryptoProvider.encryptToBase64(theParam);
	}
	
</script>
