<%@ control language="c#" inherits="EMR.DayLimitParams, EMR_deploy" %>
<script type="text/javascript">
function getFromText() {
	return document.getElementById("<%=dateRangeFromText.ClientID%>");
}
function getToText() {
	return document.getElementById("<%=dateRangeToText.ClientID%>");
}
function clearDateButtons() {
	for(var _index=0;_index<10;_index++) {
		var dateButton=getDateButton(_index);
		if (null!=dateButton) {
			dateButton.checked=false;
		}
	}
}
function getDateButton(__index) {
	return document.getElementById("<%=dateRangeButtonList.ClientID%>_"+__index);
}
function isDateButtonChecked() {
	for(var _index=0;_index<10;_index++) {
		var dateButton=getDateButton(_index);
		if (null!=dateButton) {
			if (dateButton.checked) {
				return true;
			}
		}
	}
	return false;
}
function validateDates(source, arguments) {
	var fromText=getFromText();
	var toText=getToText();
	setDateMessage("");
	if (null==fromText || null==toText) {
		if (!isDateButtonChecked()) {
			arguments.IsValid=false;
			setDateMessage("no date selected");
			return;
		}
		arguments.IsValid=true;
		return;
	}
	fromText.value=trimString(fromText.value);
	toText.value=trimString(toText.value);
	if (fromText.value.length==0 && toText.value.length==0) {
		if (isDateButtonChecked()) {
			arguments.IsValid=true;
		}
		else {
			arguments.IsValid=false;
			setDateMessage("you must select a date range or enter a 'From' and 'To' date to continue");
		}
		return;
	}
	if (isDateButtonChecked()) {
		setDateMessage("you must either select a date OR provide 'From' and 'To' dates (not both)");
		arguments.IsValid=false;
		return;
	}
	if (!isDateString(fromText.value)) {
		setDateMessage("the 'From' date is not a valid date");
		arguments.IsValid=false;
		return;
	}
	if (!isDateString(toText.value)) {
		setDateMessage("the 'To' date is not a valid date");
		arguments.IsValid=false;
		return;
	}
	var fromDate=getDateFromString(fromText.value);
	var toDate=getDateFromString(toText.value);
	if (!isFromToRangeValid(fromDate,toDate)) {
		setDateMessage("The 'To' date must follow or be the same as the 'From' date");
		arguments.IsValid=false;
		return;
	}
	arguments.IsValid=isDayDifferenceValid(fromDate,toDate);
	if (!arguments.IsValid) {
		setDateMessage("The 'To' and 'From' dates must be 14 days apart or less");
	}
}
function isDayDifferenceValid(fromDate,toDate) {
	return (toDate-fromDate)<=1123200000;	//This number is the number of milliseconds of 13 days
}
function isFromToRangeValid(fromDate,toDate) {
	if (null==fromDate || null==toDate) return false;
	if (fromDate.getFullYear()>toDate.getFullYear()) return false;
	if (fromDate.getFullYear()==toDate.getFullYear()) {
		if (fromDate.getMonth()>toDate.getMonth()) {
			return false;
		}
		if (fromDate.getMonth()==toDate.getMonth()) {
			return (fromDate.getDate()<=toDate.getDate());
		}
	}
	return true;
}
function getDateFromString(dateString) {
	var stringArray=dateString.split("/");
	return new Date(stringArray[2],stringArray[0]-1,stringArray[1]);
}
function isDateString(inputString) {
	try {
		if (!inputString.match("^(\\d{1,2}?)/(\\d{1,2}?)/(\\d{4}?)\\s*$")) {
			return false;
		}
		var stringArray=inputString.split("/");
		var testDate=new Date(stringArray[2],stringArray[0]-1,stringArray[1],0,0,0,0);
		if (stringArray[0]!=testDate.getMonth()+1 || stringArray[1]!=testDate.getDate() || stringArray[2]!=testDate.getFullYear()) {
			return false;
		}
		return true;
	}
	catch (ex) {
		return false;
	}
}
function dateTextChanged(comp) {
	if (null==comp) {
		return;
	}
	if (comp.value.length==0) {
		return;
	}
	clearDateButtons();
	comp.value=maybeReformatDate(comp.value);
}
function dateButtonClicked() {
	var fromText=getFromText();
	var toText=getToText();
	if (null==fromText || null==toText) {
		return;
	}
	fromText.value="";
	toText.value="";
}
function isDateSelected() {
	if (isDateButtonChecked()) return true;
	var fromTextField=getFromText();
	var toTextField=getToText();
	if (null!=fromTextField && null!=toTextField) {
		if (fromTextField.value.length>0 || toTextField.value.length>0) {
			return true;
		}
	}
	return false;
}
function maybeReformatDate(aString) {
	aString=aString.replace(/ /g,"").replace(/-/g,"/");
	if (aString.match("^(\\d{1,2})/(\\d{1,2})/(\\d{2})\\s*$")) {
		var index=aString.lastIndexOf("/")+1;
		var century=20;
		var year=century+aString.substr(index,index+2);
		if (year>new Date().getFullYear()) {
			year-=100;
		}
		aString=aString.substr(0,index)+year;
	}
	return aString;
}
function setDateMessage(newMessage) {
	document.getElementById("dateMessage").innerHTML=newMessage;
}
</script>
<table width="100%" style="border-style:none;border-collapse:collapse;">
	<tr>
		<td class="dateParamEntry"><asp:label id="dateRangeLabel" runat="server">Date&nbsp;Range:</asp:label></TD>
		<td width="90%" class="dateParamEntry">
			<dl style="MARGIN-TOP:0px;MARGIN-BOTTOM:0px">
				<dt>
					<asp:radiobuttonlist id="dateRangeButtonList" accessKey="R" runat="server" RepeatDirection="Horizontal"
						CssClass="dateParamEntry">
						<asp:ListItem Value="0">Today</asp:ListItem>
						<asp:ListItem Value="7" Selected="True">One Week</asp:ListItem>
						<asp:ListItem Value="14">Two Weeks</asp:ListItem>
					</asp:radiobuttonlist>
					<dt>
						<asp:label id="dateRangeFromLabel" runat="server">From:&nbsp;(mm/dd/yyyy)&nbsp;</asp:label><asp:textbox id="dateRangeFromText" accessKey="F" runat="server"></asp:textbox>&nbsp;&nbsp;
						<asp:label id="dateRangeToLabel" runat="server">To:&nbsp;(mm/dd/yyyy)&nbsp;</asp:label><asp:textbox id="dateRangeToText" accessKey="T" runat="server"></asp:textbox>&nbsp;&nbsp;
						<dt>
							<asp:customvalidator id="dateValidator" runat="server" ClientValidationFunction="validateDates" ErrorMessage="Date Problem: "
								ToolTip="Click a date buton, or enter 'from' and 'to' dates in format mm/dd/yyyy"></asp:customvalidator><label style="COLOR: red" id="dateMessage"></label></dt>
			</dl>
		</td>
		<td><asp:button id="queryButton" accessKey="Q" runat="server" Text="Query" onclick="queryButtonClick"></asp:button></td>
	</tr>
</table>
