<%@ page title="" language="C#" masterpagefile="~/AdHocWizard.master" autoeventwireup="true" inherits="EMR.HsAdHocParamReview, EMR_deploy" %>
<%@ Import Namespace="EXT.DOMAIN.mdo" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="pageNamePlaceholder" Runat="Server">
<asp:Label runat="server">The following will execute when "Submit" is clicked:</asp:Label>
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="wizardContentPlaceholder" Runat="Server">
<div style="overflow:auto;height:30em">
	<asp:Table runat="server" BorderStyle="Double" BorderWidth="1" GridLines="Both" ID="paramTable">
		<asp:TableHeaderRow>
			<asp:TableHeaderCell>Report Component</asp:TableHeaderCell>
			<asp:TableHeaderCell>Component Parameters</asp:TableHeaderCell>
		</asp:TableHeaderRow>
	</asp:Table>
</div>
</asp:Content>
<script runat="server">
	protected virtual void Page_PreRender(object sender, EventArgs e) {
		if (IsResultSet) {
			return;
		}
		IAHComponent[] selected = _adhocState.SelectedList;
		foreach (IAHComponent comp in selected) {
			TableRow row = new TableRow();
			TableCell nameCell = new TableCell();
			nameCell.Text = HttpUtility.HtmlEncode(comp.Name);
			row.Cells.Add(nameCell);
			TableCell descrCell = new TableCell();
			descrCell.Text = HttpUtility.HtmlEncode(GetParamString(comp));
			row.Cells.Add(descrCell);
			paramTable.Rows.Add(row);
		}
	}

	protected virtual string GetParamString(IAHComponent comp) {
		StringBuilder str = new StringBuilder();
		if (comp.IsDispHdrName) {
			str.Append("Report header: '");
			str.Append(comp.HdrName);
			str.Append("'");
		}
		
		if (comp.IsDispOccLimit) {
			MaybeAddComma(str);
			str.Append("Occurance limit: '");
			str.Append(comp.OccLimit);
			str.Append("'");
		}

		if (comp.IsDispTimeLimit) {
			MaybeAddComma(str);
			str.Append("Time limit: '");
			str.Append(comp.TimeLimit);
			str.Append("'");
		}

		if (comp.IsDispHLoc) {
			MaybeAddComma(str);
			str.Append("Display hospital location='");
			if (comp.IsHLocInReport) {
				str.Append("Yes");
			}
			else {
				str.Append("No");
			}
			str.Append("'");
		}

		if (comp.IsDispPrvNar) {
			MaybeAddComma(str);
			str.Append("Display provider narrative='");
			if (comp.IsPrvNarInReport) {
				str.Append("Yes");
			}
			else {
				str.Append("No");
			}
			str.Append("'");
		}

		if (comp.IsDispICDText) {
			MaybeAddComma(str);
			str.Append("ICD Text: '");
			str.Append(comp.ICDText);
			str.Append("'");
		}

		if (comp.SubItems != null && comp.SubItems.Count > 0) {
			MaybeAddComma(str);
			if (comp.SubItems.Count == 1) {
				str.Append("1 File entry: '");
				str.Append(comp.SubItems[0].Name);
				str.Append("'");
			}
			else {
				str.Append(comp.SubItems.Count);
				str.Append(" File entries: ");
				for (int i = 0; i < comp.SubItems.Count; i++) {
					if (i == comp.SubItems.Count - 1) {
						str.Append(" and ");
					}
					else if (i > 0) {
						str.Append(", ");
					}
					str.Append("'");
					str.Append(comp.SubItems[i].Name);
					str.Append("'");
				}
			}
		}
		
		return str.ToString();
	}

	protected virtual void MaybeAddComma(StringBuilder str) {
		if (str != null && str.Length > 0) {
			str.Append(", ");
		}
	}

	protected override string GetFinishButtonName() {
		return "Submit";
	}
	
</script>
