<%@ page title="" language="C#" masterpagefile="~/AdHocWizard.master" autoeventwireup="true" inherits="EMR.HsAdHocReportEdits, EMR_deploy" %>
<%@ Import Namespace="System.Collections.Generic" %>
<%@ Import Namespace="EXT.DOMAIN.hds.text" %>
<%@ Import Namespace="EXT.DOMAIN.mdo" %>
<%@ Import Namespace="EXT.DOMAIN.vistaweb.ui" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="pageNamePlaceholder" Runat="Server">
<asp:Label runat="server">Modify Report Component Parameters</asp:Label>
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="wizardContentPlaceholder" Runat="Server">
<div style="overflow:auto;height:30em">
	<table border="1">
		<thead>
			<tr>
				<th>Component Name</th>
				<th>Header Name</th>
				<th>Occurrence Limit</th>
				<th>Time Limit</th>
				<th>Display Hospital Location</th>
				<th>Display Provider Narrative</th>
				<th>ICD Text Display</th>
			</tr>
		</thead>
		<%FillInputTable(); %>
		<tbody>
			<asp:PlaceHolder runat="server" ID="tablePlaceholder" />
		</tbody>
	</table>
</div>
</asp:Content>
<script runat="server">
	protected virtual void FillInputTable() {
		IAHComponent[] selected = _adhocState.SelectedList;
		if (selected != null && selected.Length > 0) {
			for (int i = 0; i < selected.Length; i++) {
				tablePlaceholder.Controls.Add(new LiteralControl("<tr><td>" + HttpUtility.HtmlEncode(selected[i].Name) + "</td><td>"));
				if (selected[i].IsDispHdrName) {
					TextBox box = new TextBox();
					box.Text = selected[i].HdrName;
					box.ID = "hdrName" + i;
					tablePlaceholder.Controls.Add(box);
				}
				else {
					tablePlaceholder.Controls.Add(new LiteralControl("&nbsp;"));
				}
				tablePlaceholder.Controls.Add(new LiteralControl("</td><td>"));

				if (selected[i].IsDispOccLimit) {
					TextBox box = new TextBox();
					box.Text = "" + selected[i].OccLimit;
					box.ID = "occLimit" + i;
					tablePlaceholder.Controls.Add(box);
				}
				else {
					tablePlaceholder.Controls.Add(new LiteralControl("&nbsp;"));
				}
				tablePlaceholder.Controls.Add(new LiteralControl("</td><td>"));

				if (selected[i].IsDispTimeLimit) {
					Control timeControl = LoadControl("HsAdHocTimeLimitControl.ascx");
					IValueTextControl timeTextControl = (IValueTextControl)timeControl;
					timeTextControl.SelectedValue = selected[i].TimeLimit;
					timeTextControl.ID = "timeLimit" + i;
					tablePlaceholder.Controls.Add(timeControl);
				}
				else {
					tablePlaceholder.Controls.Add(new LiteralControl("&nbsp;"));
				}
				tablePlaceholder.Controls.Add(new LiteralControl("</td><td>"));

				if (selected[i].IsDispHLoc) {
					CheckBox box = new CheckBox();
					box.Checked = selected[i].IsHLocInReport;
					box.ID = "hlocCheckbox" + i;
					tablePlaceholder.Controls.Add(box);
				}
				else {
					tablePlaceholder.Controls.Add(new LiteralControl("&nbsp;"));
				}
				tablePlaceholder.Controls.Add(new LiteralControl("</td><td>"));

				if (selected[i].IsDispPrvNar) {
					CheckBox box = new CheckBox();
					box.Checked = selected[i].IsPrvNarInReport;
					box.ID = "pnarCheckbox" + i;
					tablePlaceholder.Controls.Add(box);
				}
				else {
					tablePlaceholder.Controls.Add(new LiteralControl("&nbsp;"));
				}
				tablePlaceholder.Controls.Add(new LiteralControl("</td><td>"));

				if (selected[i].IsDispICDText) {
					Control icdControl = LoadControl("HsAdHocIcdTextControl.ascx");
					IValueTextControl icdTextControl = (IValueTextControl)icdControl;
					icdTextControl.SelectedValue = selected[i].ICDText;
					icdTextControl.ID = "icdText" + i;
					tablePlaceholder.Controls.Add(icdControl);
				}
				else {
					tablePlaceholder.Controls.Add(new LiteralControl("&nbsp;"));
				}
				tablePlaceholder.Controls.Add(new LiteralControl("</td></tr>"));
			}
		}
	}

	protected override void ProcessUpdates() {
		IAHComponent[] selected = _adhocState.SelectedList;
		if (selected == null || selected.Length < 1) {
			return;
		}
		string baseControlId = Master.ClientID + ":wizardContentPlaceholder:";
		string baseHeaderName = baseControlId + "hdrName{0}";
		string baseOccLimitName = baseControlId + "occLimit{0}";
		string baseTimeLimitName = baseControlId + "timeLimit{0}:dropDownList";
		string baseHlocCheckboxName = baseControlId + "hlocCheckbox{0}";
		string basePnarCheckboxName = baseControlId + "pnarCheckbox{0}";
		string baseIcdTextName = baseControlId + "icdText{0}:dropDownList";
		IList<IAHComponent> changeList = null;
		for (int i = 0; i < selected.Length; i++) {
			AHComponent compToChange = GetShallowCopy(selected[i]);
			string val = Request.Form[String.Format(baseHeaderName, i)];
			if (val != null) {
				compToChange.HdrName = val;
			}
			
			val = Request.Form[String.Format(baseOccLimitName, i)];
			if (val != null) {
				try {
					int intVal = int.Parse(val);
					compToChange.OccLimit = intVal;
				}
				catch { }
			}

			val = Request.Form[String.Format(baseTimeLimitName, i)];
			if (val != null) {
				compToChange.TimeLimit = val;
			}

			val = Request.Form[String.Format(baseHlocCheckboxName, i)];
			compToChange.IsHLocInReport = (val!=null);

			val = Request.Form[String.Format(basePnarCheckboxName, i)];
			compToChange.IsPrvNarInReport = (val != null);

			val = Request.Form[String.Format(baseIcdTextName, i)];
			if (val != null) {
				compToChange.ICDText = val;
			}

			if (compToChange != null) {
				if (changeList == null) {
					changeList = new List<IAHComponent>();
				}
				changeList.Add(compToChange);
			}
		}
		HsAdHocWizardController.SetReportComponentEdits(_adhocState, changeList);
	}

	protected virtual AHComponent GetShallowCopy(IAHComponent comp) {
		AHComponent newComp = new AHComponent();
		newComp.Id = comp.Id;
		newComp.HdrName = comp.HdrName;
		newComp.ICDText = comp.ICDText;
		newComp.IsDispHdrName = comp.IsDispHdrName;
		newComp.IsDispHLoc = comp.IsDispHLoc;
		newComp.IsDispICDText = comp.IsDispICDText;
		newComp.IsDispOccLimit = comp.IsDispOccLimit;
		newComp.IsDispPrvNar = comp.IsDispPrvNar;
		newComp.IsDispTimeLimit = comp.IsDispTimeLimit;
		newComp.IsHLocInReport = comp.IsHLocInReport;
		newComp.IsPrvNarInReport = comp.IsPrvNarInReport;
		newComp.Name = comp.Name;
		newComp.OccLimit = comp.OccLimit;
		newComp.SubCompFile = comp.SubCompFile;
		newComp.TimeLimit = comp.TimeLimit;
		return newComp;
	}
	
</script>
