<%@ page title="" language="C#" masterpagefile="~/AdHocWizard.master" autoeventwireup="true" inherits="EMR.HsAdHocSubReportOrder, EMR_deploy" %>
<%@ Import Namespace="System.Collections.Generic" %>
<%@ Import Namespace="EXT.DOMAIN.vistaweb.ui" %>
<%@ Import Namespace="EXT.DOMAIN.mdo" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="pageNamePlaceholder" Runat="Server">
<asp:Label runat="server">Modify File Selection Order for '</asp:Label><asp:Label runat="server" ID="fileNameLabel"></asp:Label><asp:Label runat="server">'</asp:Label>
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="wizardContentPlaceholder" Runat="Server">
<div style="overflow:auto;height:30em">
	<table border="1">
		<thead>
			<tr>
				<th>File Selection</th>
				<th>Display Order</th>
			</tr>
		</thead>
		<%FillInTable(); %>
		<tbody>
			<asp:PlaceHolder runat="server" ID="tablePlaceholder"/>
		</tbody>
	</table>
</div>
<br />
<asp:Button ID="applyChangesButton" runat="server" 
		Text="Apply Display Order Changes" CssClass="myButton" 
		onclick="applyChangesButton_Click" />
<br />
<br />
</asp:Content>
<script runat="server">
	protected virtual void Page_PreRender(object sender, EventArgs e) {
		if (IsResultSet) {
			return;
		}
		fileNameLabel.Text = component.Name;
	}

	protected virtual void FillInTable() {
		if (component != null && component.SubItems != null && component.SubItems.Count > 0) {
			for (int i = 0; i < component.SubItems.Count; i++) {
				tablePlaceholder.Controls.Add(new LiteralControl("<tr><td>" + HttpUtility.HtmlEncode(component.SubItems[i].Name) + "</td><td>"));
				TextBox box = new TextBox();
				box.Text = (i + 1).ToString();
				box.ID = "displayOrder" + i;
				tablePlaceholder.Controls.Add(box);
				tablePlaceholder.Controls.Add(new LiteralControl("</td></tr>\n"));
			}
		}
	}

	protected override IList<AdHocComponentPosition> GetNewPositionList() {
		IList<AdHocComponentPosition> posList = null;
		if (component != null && component.SubItems != null && component.SubItems.Count > 0) {
			string baseInputBoxName = Master.ClientID + ":wizardContentPlaceholder:displayOrder";
			for (int i = 0; i < component.SubItems.Count; i++) {
				int inValue = i + 1;
				try {
					string val = Request.Form[baseInputBoxName + i.ToString()];
					if (val != null) {
						inValue = int.Parse(val);
					}
				}
				catch { }
				if (inValue != (i + 1)) {
					if (posList == null) {
						posList = new List<AdHocComponentPosition>();
					}
					posList.Add(new AdHocComponentPosition(component.SubItems[i].Id, inValue));
				}
			}
		}
		return posList;
	}

</script>
