<%@ control language="c#" inherits="EMR.ParamsAndQueryControl, EMR_deploy" %>
<!-- paramsAndQueryControl-->
<script type="text/javascript">
function numberAllChanged() {
	var numBox=getNumberBox();
	var numCheck=getNumberCheck();
	if (null==numBox || null==numCheck) {
		return;
	}
	if (numCheck.checked) {
		numBox.value="";
		numBox.disabled=true;
	}
	else {
		numBox.disabled=false;
	}
	updateNumberMessage();
}
function updateNumberMessage() {
	var numCheck=getNumberCheck();
	var numMessage=getNumWarningMessage();
	if (null===numMessage) return;
	if (null!=numCheck && numCheck.checked) {
		numMessage.style.visibility="visible";
	}
	else {
		numMessage.style.visibility="hidden";
	}
}
function getNumWarningMessage() {
	return document.getElementById("<%=numberWarningMessage.ClientID%>");
}
function getNumberBox() {
	return document.getElementById("<%=numberText.ClientID%>");
}
function getNumberCheck() {
	return document.getElementById("<%=numberAllDataCheckbox.ClientID%>");
}
function getFromText() {
	return document.getElementById("<%=dateRangeFromText.ClientID%>");
}
function getToText() {
	return document.getElementById("<%=dateRangeToText.ClientID%>");
}
function clearDateButtons() {
	for(var _index=0;_index<10;_index++) {
		var dateButton=getDateButton(_index);
		if (null!=dateButton) {
			dateButton.checked=false;
		}
	}
}
function getDateButton(__index) {
	return document.getElementById("<%=dateRangeButtonList.ClientID%>_"+__index);
}
function getReportButton(__index) {
	return document.getElementById("<%=reportTypeButtons.ClientID%>_" + __index);
}
function isDateButtonChecked() {
	for(var _index=0;_index<10;_index++) {
		var dateButton=getDateButton(_index);
		if (null!=dateButton) {
			if (dateButton.checked) {
				return true;
			}
		}
	}
	return false;
}
function isReportButtonChecked() {
	return null!=getCheckedReportButton();
}
function validateDates(source, arguments) {
	var fromText=getFromText();
	var toText=getToText();
	setDateMessage("");
	if (null==fromText || null==toText) {
		if (!isDateButtonChecked()) {
			arguments.IsValid=false;
			setDateMessage("no date selected");
			return;
		}
		arguments.IsValid=true;
		return;
	}
	fromText.value=trimString(fromText.value);
	toText.value=trimString(toText.value);
	if (fromText.value.length==0 && toText.value.length==0) {
		if (isDateButtonChecked()) {
			arguments.IsValid=true;
		}
		else {
			arguments.IsValid=false;
			setDateMessage("you must select a date range or enter a 'From' and 'To' date to continue");
		}
		return;
	}
	if (isDateButtonChecked()) {
		setDateMessage("you must either select a date OR provide 'From' and 'To' dates (not both)");
		arguments.IsValid=false;
		return;
	}
	if (!isDateString(fromText.value)) {
		setDateMessage("the 'From' date is not a valid date");
		arguments.IsValid=false;
		return;
	}
	if (!isDateString(toText.value)) {
		setDateMessage("the 'To' date is not a valid date");
		arguments.IsValid=false;
		return;
	}
	var fromDate=getDateFromString(fromText.value);
	var toDate=getDateFromString(toText.value);
	arguments.IsValid=isFromToRangeValid(fromDate,toDate);
	if (!arguments.IsValid) setDateMessage("The 'To' date must follow or be the same as the 'From' date");
}
function isFromToRangeValid(fromDate,toDate) {
	if (null==fromDate || null==toDate) return false;
	if (fromDate.getFullYear()>toDate.getFullYear()) return false;
	if (fromDate.getFullYear()==toDate.getFullYear()) {
		if (fromDate.getMonth()>toDate.getMonth()) {
			return false;
		}
		if (fromDate.getMonth()==toDate.getMonth()) {
			return (fromDate.getDate()<=toDate.getDate());
		}
	}
	return true;
}
function getDateFromString(dateString) {
	var stringArray=dateString.split("/");
	return new Date(stringArray[2],stringArray[0]-1,stringArray[1]);
}
function isDateString(inputString) {
	try {
		if (!inputString.match("^(\\d{1,2}?)/(\\d{1,2}?)/(\\d{4}?)\\s*$")) {
			return false;
		}
		var stringArray=inputString.split("/");
		var testDate=new Date(stringArray[2],stringArray[0]-1,stringArray[1],0,0,0,0);
		if (stringArray[0]!=testDate.getMonth()+1 || stringArray[1]!=testDate.getDate() || stringArray[2]!=testDate.getFullYear()) {
			return false;
		}
		return true;
	}
	catch (ex) {
		return false;
	}
}
function dateTextChanged(comp) {
	if (null==comp) {
		return;
	}
	if (comp.value.length==0) {
		return;
	}
	clearDateButtons();
	comp.value=maybeReformatDate(comp.value);
}
function dateButtonClicked() {
	var fromText=getFromText();
	var toText=getToText();
	if (null==fromText || null==toText) {
		return;
	}
	fromText.value="";
	toText.value="";
}
function numberTextChanged() {
	var numCheck=getNumberCheck();
	if (null!=numCheck) {
		numCheck.checked=false;
	}
}
function validateNumber(source, arguments) {
	var numText=getNumberBox();
	var numCheck=getNumberCheck();
	if (null==numText || null==numCheck) {
		arguments.IsValid=true;
		return;
	}
	try {
		if (numText.value.length>0) {
			if (numText.value>0) {
				arguments.IsValid=true;
				return;
			}
		}
		else if (numCheck.checked) {
			arguments.IsValid=true;
			return;
		}
	}
	catch (ex) {
	}
	arguments.IsValid=false;
}
function isDateSelected() {
	if (isDateButtonChecked()) return true;
	var fromTextField=getFromText();
	var toTextField=getToText();
	if (null!=fromTextField && null!=toTextField) {
		if (fromTextField.value.length>0 || toTextField.value.length>0) {
			return true;
		}
	}
	return false;
}
function checkReportAndDateRange(source, arguments) {
	if (isReportButtonChecked()&&!isDateSelected()) {
		arguments.IsValid=false;
		return;
	}
	arguments.IsValid=true;
}
function getCheckedReportButton() {
	for(var i=0;i<10;i++) {
		var reportButton=getReportButton(i);
		if (null!=reportButton) {
			if (reportButton.checked) {
				return reportButton;
			}
		}
	}
	return null;
}
function reportTypeButtonClicked() {
	var reportButton=getCheckedReportButton();
	if(null==reportButton) return;
	if(reportButton.value!="AnatomicPathologySummaries" && reportButton.value!="BloodBankSummaries") return;
	var dateButton=getDateButton(8);
	if(null==dateButton) return;
	dateButton.click();
}
function maybeReformatDate(aString) {
	aString=aString.replace(/ /g,"").replace(/-/g,"/");
	if (aString.match("^(\\d{1,2})/(\\d{1,2})/(\\d{2})\\s*$")) {
		var index=aString.lastIndexOf("/")+1;
		var century=20;
		var year=century+aString.substr(index,index+2);
		if (year>new Date().getFullYear()) {
			year-=100;
		}
		aString=aString.substr(0,index)+year;
	}
	return aString;
}
function setDateMessage(newMessage) {
	document.getElementById("dateMessage").innerHTML=newMessage;
}
</script>
<div>
<table width="100%" style="BORDER-STYLE:none;BORDER-COLLAPSE:collapse;">
	<tr>
		<td class="reportTypeDescr"><asp:label id="reportTypeLabel" runat="server">Report&nbsp;Type:</asp:label></td>
		<td class="reportTypeEntry" style="width:90%">
			<dl style="MARGIN-TOP:0px;MARGIN-BOTTOM:0px">
				<dt>
					<asp:radiobuttonlist id="reportTypeButtons" runat="server" RepeatDirection="Horizontal" accessKey="T"
						CssClass="reportTypeButtons">
						<asp:ListItem Value="CumulativeLabReports">Cumulative</asp:ListItem>
						<asp:ListItem Value="LabTestSummaries">All Tests by Date</asp:ListItem>
						<asp:ListItem Value="MicrobiologySummaries">Microbiology</asp:ListItem>
						<asp:ListItem Value="AnatomicPathologySummaries">Anatomic Pathology</asp:ListItem>
						<asp:ListItem Value="BloodBankSummaries">Blood Bank</asp:ListItem>
						<asp:ListItem Value="LabStatusSummaries">Lab Status</asp:ListItem>
					</asp:radiobuttonlist>
					</dt>
					<dt>
						<asp:CustomValidator id="reportTypeAndDatesValidator" runat="server" ErrorMessage="A date range must be chosen for the selected report&nbsp;&nbsp;"
							ClientValidationFunction="checkReportAndDateRange"></asp:CustomValidator><asp:RequiredFieldValidator id="reportTypeSelectedValidator" runat="server" ErrorMessage="Please select a report to continue"
							ControlToValidate="reportTypeButtons"></asp:RequiredFieldValidator></dt>
			</dl>
		</td>
		<td></td>
	</tr>
	<tr>
		<td class="dateParamDescr"><asp:label id="dateRangeLabel" runat="server">Date&nbsp;Range:</asp:label></td>
		<td class="dateParamEntry" style="width:90%">
			<dl style="MARGIN-TOP:0px;MARGIN-BOTTOM:0px">
				<dt>
					<asp:radiobuttonlist id="dateRangeButtonList" accessKey="R" runat="server" RepeatDirection="Horizontal"
						CssClass="dateParamEntry">
						<asp:ListItem Value="0">Today</asp:ListItem>
						<asp:ListItem Value="7">One Week</asp:ListItem>
						<asp:ListItem Value="14">Two Weeks</asp:ListItem>
						<asp:ListItem Value="30">One Month</asp:ListItem>
						<asp:ListItem Value="60">Two Months</asp:ListItem>
						<asp:ListItem Value="183">Six Months</asp:ListItem>
						<asp:ListItem Value="365">One Year</asp:ListItem>
						<asp:ListItem Value="730">Two Years</asp:ListItem>
						<asp:ListItem Value="99999">All Dates</asp:ListItem>
					</asp:radiobuttonlist>
					</dt>
					<dt>
						<asp:label id="dateRangeFromLabel" runat="server">From:&nbsp;(mm/dd/yyyy)&nbsp;</asp:label><asp:textbox id="dateRangeFromText" accessKey="F" runat="server"></asp:textbox>&nbsp;&nbsp;
						<asp:label id="dateRangeToLabel" runat="server">To:&nbsp;(mm/dd/yyyy)&nbsp;</asp:label><asp:textbox id="dateRangeToText" accessKey="T" runat="server"></asp:textbox>&nbsp;&nbsp;
		</dt>				
						<dt>
							<asp:customvalidator id="dateValidator" runat="server" ClientValidationFunction="validateDates" ErrorMessage="Date Problem: "
								ToolTip="Click a date buton, or enter 'from' and 'to' dates in format mm/dd/yyyy"></asp:customvalidator><label style="COLOR: red" id="dateMessage"></label></dt>
			</dl>
		</td>
		<td><asp:button id="queryButton" accessKey="Q" runat="server" Text="Query" onclick="queryButtonClick"></asp:button></td>
	</tr>
	<tr>
		<td class="recCountDescr"><asp:label id="numberLabel" runat="server">Maximum Number/Site:</asp:label></td>
		<td class="recCountEntry" style="width:90%"><asp:textbox id="numberText" runat="server" ToolTip="Enter a value of 1 or higher to limit the number of records returned"
				accessKey="N" Width="72px" Wrap="False">50</asp:textbox>
			<asp:checkbox id="numberAllDataCheckbox" accessKey="A" runat="server" ToolTip="Check this box to return all data for this query"
				Text="All Reports"></asp:checkbox><asp:regularexpressionvalidator id="numberValidator" runat="server" ErrorMessage="&nbsp;invalid number&nbsp;" ControlToValidate="numberText"
				ValidationExpression="^\d*$" Display="Dynamic"></asp:regularexpressionvalidator><asp:customvalidator id="numberTextValidator" runat="server" ClientValidationFunction="validateNumber"
				ErrorMessage="&nbsp;&nbsp;enter a number 1 or higher or check 'All Reports' to continue" Display="Dynamic"></asp:customvalidator><asp:Label Runat="server" ID="numberWarningMessage">&nbsp;CAUTION: This will override the maximum number of reports per site and may affect system performance</asp:Label></td>
		<td></td>
	</tr>
</table>
</div>
<script type="text/javascript">
updateNumberMessage();
</script>
