<%@ page language="c#" inherits="EMR.PatientSelection, EMR_deploy" validaterequest="false" %>

<%@ Register Src="PtMiniDemographics.ascx" TagName="PtMiniDemographics" TagPrefix="uc1" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>Patient Selection</title>
		<link href="resources/css/main.css" type="text/css" rel="stylesheet"/>
		<script type="text/javascript" src="resources/scripts/js/JSExtras.js"></script>
		<script type="text/javascript" src="resources/scripts/js/ajax.js"></script>
	</head>
	<body onload="init_local();setupFocus();">
        <a href="#findBox" title="skip to content" class="skipToContentLink"></a>
		<img src="resources/images/PatientSelection.gif" alt="Patient Selection image" style="position:relative;float:left"/>
		<img src="resources/images/moduleTitle.gif" alt="Medical record image" style="position:relative;float:right"/>
		<br/>
		<hr style="clear:both;color:#cc0000"/>
		<form id="patientSelectionForm" method="post" runat="server">
			<asp:Panel ID="ssnPanel" runat="server" Visible="False" CssClass="spanHdr" Width="100%">
				<asp:Label ID="Label1" runat="server" ForeColor="#C00000" Text="--- Cannot visit other sites ---"></asp:Label><br />
				<br />
				<asp:Label ID="Label2" runat="server" ForeColor="Red" Text="Contact your local IRM/Computer support staff to have your SSN corrected, then restart the session."></asp:Label>
			</asp:Panel>
			<br />
			<span class="hdr">The current lookup site is <asp:Label ID="lookupSiteLabel" Runat="server"></asp:Label>.</span>
            <p>To lookup a patient in a different site, choose from the list on the left.</p>
			<p>If you don't see a list of sites in the control panel you are constrained to 
			selecting patients only in the site at which you logged on. You will still get 
			data from everywhere in VHA however.</p>
			<span class="hdr">If you need to look up a patient who has not been seen at your 
				VAMC (a remote site patient lookup,) you must request Special User access to 
				VistAWeb. Ask for instructions for Special User access by emailing the VHA CO 
				CAPRI access team: <a href="mailto:vhacocapri@DOMAIN.EXT">vhacocapri@DOMAIN.EXT</a></span>
			<br />
			<br />
			<table border="0">
				<tr style="height:2em">
					<td></td>
					<td colspan="4">
						<textarea class="readonly spanHdr" rows="1" tabindex="1" cols="80" readonly="readonly" style="overflow:hidden"><%=_statusMessage%></textarea>
					</td>
				</tr>
				<tr>
					<td class="lbl" valign="top" align="right">Look for:</td>
					<td valign="top" class="findCell">
						<asp:TextBox ID="findBox" Runat="server" tabIndex="10" CssClass="findComponent"></asp:TextBox>
					</td>
					<td></td>
					<td valign="top">
						<asp:Button ID="findButton" Runat="server" CssClass="myButton" Width="100%" Text="Find" tabIndex="20" onclick="findButton_Click"></asp:Button>
					</td>
					<td></td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<!-- this ridiculous line below is necessary, 
					otherwise some browsers squash the buttons 
					when the screen width gets below a certain point-->
					<td><span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span></td>
					<td>&nbsp;</td>
				</tr>
				<tr>
					<td class="lbl" valign="top">Matches:
					</td>
					<td rowspan="6" valign="top" class="findCell">
						<asp:ListBox ID="matchesList" Runat="server" AutoPostBack="False" CssClass="ptSelectionList"
							tabIndex="30"></asp:ListBox>
					</td>
					<td>&nbsp;</td>
					<td valign="top" align="left">
						<asp:button id="okButton" runat="server" Width="100%" Text="OK" CssClass="myButton" Enabled="False" tabIndex="40" onclick="okButton_Click"></asp:button>
					</td>
					<td></td>
				</tr>
				<tr>
					<td></td>
					<td></td>
					<td valign="top" align="left">
						<asp:button id="cancelButton" runat="server" Width="100%" Text="Cancel" CssClass="myButton"
							tabIndex="50" onclick="cancelButton_Click"></asp:button>
					</td>
					<td style="width:200px">&nbsp;</td>
				</tr>
				<tr>
					<td></td>
					<td></td>
					<td class="lbl" valign="top" colspan="2" rowspan="3">
						<div id="demoInfo" style="height:100%">
							<uc1:PtMiniDemographics ID="ptMiniDemographics" runat="server" Visible="false" />
						</div>
					</td>
				</tr>
				<tr>
					<td></td>
					<td style="width:19px"></td>
				</tr>
				<tr>
					<td></td>
					<td></td>
				</tr>
				<tr>
					<td></td>
					<td></td>
					<td valign="top" align="left">
						<asp:button id="moreButton" runat="server" Width="100%" Text="More names..." CssClass="myButton"
							Enabled="False" tabIndex="80" onclick="moreButton_Click"></asp:button>
					</td>
					<td></td>
				</tr>
			</table>
		</form>
		<script type="text/javascript">
function init_local() {
	document.getElementById("findBox").focus();
	setupTimeout();
}

function setupFocus() {
	var _findBox = document.getElementById("findBox");

	if (null == _findBox) {
		_findBox.focus();
		return
	};

	if (_findBox.value == "") {
		_findBox.focus();
		return;
	}
	var _matchList = document.getElementById("matchesList");
	if (null != _matchList) {
		var _listItems = _matchList.getElementsByTagName("option");
		if (_listItems != null && _listItems.length > 0) {
			_matchList.focus();
			//_findBox.focus();
			return;
		}
	}


}

function loadPtInfo() {
	document.getElementById("demoInfo").innerHTML = "&nbsp;<br>&nbsp;<br>&nbsp;";
	lastSelectedPt = -1;
	setupCallPtData();
	document.getElementById("matchesList").focus();
}

function loadPtInfoAsync() {
	var matches = document.getElementsByTagName("option");
	for (var i=0;i<matches.length;i++) {
	    if (matches[i].selected){
	        lastSelectedPt = i;
	        break;
		}
	}
	if (lastSelectedPt<0) {
		return;
	}
	document.getElementById("demoInfo").innerHTML="<img src='resources/images/loading.gif'/>";
	ajax.callPage("GetPtInfo.aspx?index=" + lastSelectedPt, callBack);
	document.getElementById("matchesList").focus();
}

function setupCallPtData() {
	if(null!=lastPtTimeout) {
		window.clearTimeout(lastPtTimeout);
	}
	lastPtTimeout=window.setTimeout("loadPtInfoAsync()",300);
}

function callBack(_data) {
	var strings=_data.split("!!!!!");
	var idx=strings[1];
	var demoInfo=strings[2];
	if (lastSelectedPt == parseInt(idx,10)) {
		document.getElementById("demoInfo").innerHTML=demoInfo;
	}	
}
var ajax=new AJAX();
ajax.setBlankPage("blank.htm");
var lastSelectedPt;
var lastPtTimeout;
		</script>
	</body>
</html>
<script runat="server">
	protected override void SetStartStatus() {
		_statusMessage = "Enter a patient name or identifier and click FIND.";
	}

	protected override void SetSelectStatus() {
		_statusMessage = "Select patient from Match list and click OK.";
	}

	protected override void SetNoMatchesStatus() {
		_statusMessage = "No matches. Enter a patient name or identifier and click FIND.";
	}

	protected override void SetNoLookupStatus() {
		_statusMessage = "No lookup criterion! Enter a patient name or identifier and click FIND.";
	}

	protected override void SetErrorStatus() {
		_statusMessage = "Error doing lookup";
	}
	
</script>
