<%@ Register TagPrefix="uc1" TagName="Version" Src="Version.ascx" %>
<%@ page masterpagefile="~/ReportPage.master" language="c#" inherits="EMR.Sites, EMR_deploy" enablesessionstate="ReadOnly" %>
<%@ Register Src="AwivMissingComp.ascx" TagName="AwivMissingComp" TagPrefix="uc3" %>
<%@ Register Src="RecordFlags.ascx" TagName="RecordFlags" TagPrefix="uc2" %>
<%@ Register TagPrefix="uc1" TagName="HelpContactControl" Src="~/HelpContactControl.ascx" %>
<%@ import Namespace="EXT.DOMAIN.vistaweb.ui"  %>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" Runat="Server">
		<div style="width:100%">
		<%		
		    DateTime aTimestamp = DateTime.Now;
			if (Session[EXT.DOMAIN.vistaweb.ui.UiConstants.DATE] != null) {
				aTimestamp = (DateTime)Session[EXT.DOMAIN.vistaweb.ui.UiConstants.DATE];
			}
			dateRunLabel.Text = aTimestamp.ToString(dateTimePattern);	
			 %>
			<h2 style="text-align:center;">Site Connection Summary (<asp:Label ID="dateRunLabel" runat="server" Text="local date/time"></asp:Label>)</h2>
			<uc2:RecordFlags id="recordFlagControl" runat="server"></uc2:RecordFlags>
			<p/>
				<b>Data for this patient can be retrieved from the following sites:</b><br/>
				<table cellpadding="2" cellspacing="2" border="1">
					<thead>
						<tr>
							<th>Site Name</th>
							<th>Patient Name</th>
							<th>SSN</th>
							<th>DOB</th>
							<th>Deceased Date</th>
							<th>Sensitivity</th>
							<th>Last Seen</th>
							<%if(revisionUncommon) {%> <!--th title="This column indicates the installed OR CPRS GUI CHART level at the given site">CPRS Server Version</th-->
							<%}%>
						</tr>
					</thead>
					<tbody>
						<%foreach (EXT.DOMAIN.mdo.site.IFacility aSite in expandedSiteArray) {%>
						<tr>
							<th scope="row" align="left" title="<%=HttpUtility.HtmlEncode(EXT.DOMAIN.mdo.site.SiteHelper.GetSiteNameLF(aSite))%>"><%=HttpUtility.HtmlEncode(aSite.Name)%> (<i><%=getSiteMonikerFromSiteId(aSite.Id)%></i>) <%if (aSite is EXT.DOMAIN.mdo.site.IFederatedFacility) {
																													EXT.DOMAIN.mdo.site.IFederatedFacility fSite = (EXT.DOMAIN.mdo.site.IFederatedFacility)aSite; if (fSite.Disclaimers != null && fSite.Disclaimers.Length > 0) {%><br /><a href="javascript:viewDetail('SiteDisclaimers.aspx?id=<%=HttpUtility.UrlEncode(fSite.Id)%>')" title="Disclaimer information for <%=HttpUtility.HtmlEncode(fSite.Name)%>">Disclaimers</a><%}}%></th>
							<td><%=personNameFormat.formatText(patient.PrimaryName)%></td>
							<td><%=patient.NationalId%></td>
							<td><%=getPatientDob()%></td>
							<td><%=getPatientDod(aSite)%></td>
							<td align="center"><%if (isPatientSensitive(aSite)) {%>Y<%}%></td>
							<td><%=getDateLastSeen(aSite)%></td>
							<%if (revisionUncommon) {%> <!--td><%if(versions!=null){%><%=versions.ToString()%><%}else{%>N/A<%}%></td--><%}%>
						</tr>
						<%}%>
					</tbody>
				</table>

			<%if(exceptionSites!=null) {
		 if (EXT.DOMAIN.vistaweb.ui.SpawnedHelper.isSpawned(Session)) {
			 spawnedMessage.Visible = true;
			 standAloneMessage.Visible = false;
		 }
		 else {
			 spawnedMessage.Visible = false;
			 standAloneMessage.Visible = true;
		 }
		 %>
			<p/>
				<span style="font-weight:bold;">Data for this patient cannot be retrieved from the sites shown below due to network or 
				remote system problems.  To attempt to reach those systems again, <asp:Label ID="standAloneMessage" runat="server" Text="please see the message field below and/or re-select the patient ."></asp:Label>
					<asp:Label ID="spawnedMessage" runat="server" Text="please close the browser window and restart VistAWeb from CPRS."></asp:Label></span><br/>
				<table cellpadding="2" cellspacing="2" border="1">
					<thead>
						<tr>
							<th>Site Name</th>
							<th>Message</th>
							<th>Last Seen</th>
						</tr>
					</thead>
					<tbody>
						<%for (int i=0;i<exceptionSites.Length;i++) {%>
						<tr>
                            <th scope="row" align="left"><%=exceptionSites[i].Site.Name%> (<i><%=exceptionSites[i].Site.Moniker%></i>)</th>
							<td><%=exceptionSites[i].Exception.Message%></td>
							<td><%=formatMdoDate(exceptionSites[i].LastSeenDate)%></td>
						</tr>
						<%}%>
					</tbody>
				</table>
			<%}
			 if (!IsAwivDisabled && Session[EXT.DOMAIN.vistaweb.ui.UiConstants.AWIV_AVAILABLE] == null) {
				 awivMissingComp.Visible = true;
				 %><br /><%
			 }
			 else {
				 awivMissingComp.Visible = false;
			 }        	
			%>
			<uc3:AwivMissingComp ID="awivMissingComp" runat="server" />
			<br />
			<p>
				There is also a stand-alone version of VistAWeb that is not spawned from the 
				CPRS Tools menu. This version is for users who need to select patients from 
				sites other than their home site. The URL is <b>https://vistaweb.DOMAIN.EXT</b>.
			</p>
			<p>
				<uc1:HelpContactControl id="helpContactControl" runat="server"></uc1:HelpContactControl>
			</p>
			<p>
				<span class="hdr">VistaWeb is a product of the Office of Information.</span>
			</p>
			<p>
				<uc1:Version id="version" runat="server"></uc1:Version>
			</p>
		</div>
</asp:Content>
<script runat="server">
        protected override void setupReportTitle(IImageAware reportTitle)
        {
            reportTitle.ImageText = "resources/images/sites.gif";
            reportTitle.AltImage = "Sites";
	    }
</script>
