<%@ page language="c#" inherits="EMR.VitalsChartGraph, EMR_deploy" autoeventwireup="true" %>
<%@ Register TagPrefix="dcwc" Namespace="Dundas.Charting.WebControl" Assembly="DundasWebChart" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title></title>
		<link href="resources/css/main.css" type="text/css" rel="stylesheet"/>
		<script type="text/javascript" src="resources/scripts/js/JSExtras.js"></script>
		<script type="text/javascript" src="resources/scripts/js/dialogWindow.js"></script>
		<script type="text/javascript" src="resources/scripts/js/common.js"></script>
	</head>
	<body onload="setupTimeout();local_init()">
		<form id="vitalsChartGraphForm" method="post" runat="server">
		    <b>Clicking on a vital type will display the vital graph without refreshing the page</b>
			<table border="1px">
				<tr>
					<td class="lbl">Vital&nbsp;Type</td>
					<td class="vitalParameter"><asp:RadioButtonList id="vitalTypeButtons" runat="server" AutoPostBack="True" RepeatLayout="Flow" RepeatDirection="Horizontal">
							<asp:ListItem Value="temperature">Temperature</asp:ListItem>
							<asp:ListItem Value="pulse">Pulse</asp:ListItem>
							<asp:ListItem Value="respiration">Respiration</asp:ListItem>
							<asp:ListItem Value="bloodpressure">Blood&#160;Pressure</asp:ListItem>
							<asp:ListItem Value="height">Height</asp:ListItem>
							<asp:ListItem Value="weight">Weight</asp:ListItem>
							<asp:ListItem Value="pain">Pain</asp:ListItem>
							<asp:ListItem Value="oximetry">Oximetry</asp:ListItem>
							<asp:ListItem Value="glucose">Glucose</asp:ListItem>
						</asp:RadioButtonList><asp:RequiredFieldValidator id="vitalTypeValidator" runat="server" ErrorMessage="Please select a vital type"
							ControlToValidate="vitalTypeButtons"></asp:RequiredFieldValidator></td>
				</tr>
				<tr>
					<td class="lbl">Chart&nbsp;Type</td>
					<td class="vitalParameter"><asp:RadioButtonList id="chartTypeButtons" runat="server" AutoPostBack="True" RepeatDirection="Horizontal"
							RepeatLayout="Flow">
							<asp:ListItem Value="line" Selected="True">Line</asp:ListItem>
							<asp:ListItem Value="spline">Spline</asp:ListItem>
							<asp:ListItem Value="bar">Bar</asp:ListItem>
							<asp:ListItem Value="area">Area</asp:ListItem>
						</asp:RadioButtonList></td>
				</tr>
				<tr>
					<td class="lbl">Dimension</td>
					<td class="vitalParameter"><asp:RadioButtonList id="dimensionButtons" runat="server" AutoPostBack="True" RepeatDirection="Horizontal"
							RepeatLayout="Flow">
							<asp:ListItem Value="2d" Selected="True">2D</asp:ListItem>
							<asp:ListItem Value="3d">3D</asp:ListItem>
						</asp:RadioButtonList></td>
				</tr>
			</table>
			<asp:Panel ID="GraphPanel" Runat="server" Visible="False">
				<DCWC:CHART id="Chart1" runat="server" Visible="true" ImageUrl="resources/images/temp/ChartPic_#SEQ(300,3)"
					ImageType="Png" Palette="Pastel" BackColor="gainsboro" TitleFontColor=" " Width="820px"
					Height="260px">
					<BorderSkin SkinStyle="Emboss"></BorderSkin>
					<Legends>
						<dcwc:Legend Name="Default" BackColor="Gainsboro"></dcwc:Legend>
					</Legends>
					<ChartAreas>
						<dcwc:ChartArea Name="Default" BorderColor="" BackColor="Transparent">
							<AxisX Margin="False"></AxisX>
						</dcwc:ChartArea>
					</ChartAreas>
				</DCWC:CHART>
				<br/>
				<a onclick="printReport();" href="#">Print Page</a>
			</asp:Panel>
		</form>
		<script type="text/javascript">
function local_init()
{
  document.getElementById("vitalTypeButtons_0").focus();
  for (var i= 0;i<10;i++) {
	var radBtn = document.getElementById("vitalTypeButtons_" + i);	 
	if (null!=radBtn) {
		if (radBtn.checked) {
			radBtn.focus();
			break;
		}
	}
  }  
}

		</script>
	</body>
</html>
