<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:n1="http://www.springframework.net">
	<xsl:output method="html"/>

<xsl:template match="/">
    <html>
		<head>
			<link href="css/ControlPanel.css" type="text/css" rel="stylesheet"/>
		</head>
		<body>
			<img src="images/vistaWeb.gif" alt="Selectable Item" class="link"/>
			<br/>
			<br/>
			<input type="button" value="Logoff" class="myButton"></input>
			<xsl:apply-templates select="n1:objects/n1:object[@type='TreeTOC.aspx']/n1:property[@name='menuList']"></xsl:apply-templates>
			<br/>
			<input type="button" value="Refresh Patient Data" class="myButton" style="width:150px"></input>
			<br/>
			<br/>
			<xsl:text>* - Pages with HDR data</xsl:text>
			<br/>
			<xsl:text disable-output-escaping="yes"><![CDATA[&dagger;]]> - Pages with BHIE data (Dept. of Defense)</xsl:text>
			<br/>
			<xsl:text disable-output-escaping="yes"><![CDATA[&Dagger;]]> - Pages with </xsl:text><a href='http://healthit.hhs.ext/portal/server.pt?open=512&amp;objID=1142&amp;parentname=CommunityPage&amp;parentid=2&amp;mode=2&amp;in_hi_userid=10741&amp;cached=true' title="Click here to learn more about NwHIN" target="_blank" class="external"><img src= "images/icons/external.png" alt="External Link to the NwHIN Web Site"/>NwHIN</a><xsl:text> data</xsl:text>
			<br/>
			<br/>
			<xsl:text>Warning!  Avoid using "Back" button</xsl:text>
		</body>
    </html>
</xsl:template>

	<xsl:template match="n1:list">
		<div id="nav">
			<ul>
				<xsl:apply-templates/>
			</ul>
		</div>
	</xsl:template>

	<xsl:template match="n1:ref[@local='vtaLink']">
		<li>
			<a href='https://vta.DOMAIN.EXT' target='_blank' title='Opens a new window to the Veterans Tracking Application' class='external'>
				<img src="images/icons/external.png" alt="External Link" class="external"/> VTA
			</a>

		</li>
	</xsl:template>
	
	<xsl:template match="n1:object[@parent='menuItem' or @parent='gridMenuItem' or @parent='textRecordMenuItem']">
		<li>
			<a href='#'>
				<xsl:call-template name="processBullet"/>
				<xsl:apply-templates select="n1:property[@name='title' or @name='Title']"></xsl:apply-templates>
				<xsl:call-template name="processAnnotations"/>
			</a>
			<xsl:apply-templates select="n1:property[@name='Subitems']/n1:list"/>
		</li>
	</xsl:template>

	<xsl:template name="processBullet">
		<xsl:choose>
			<xsl:when test="n1:property[@name='Subitems']">
				<img src="images/icons/minus-sign.gif" alt="Selectable Item" class="node-down"/>
			</xsl:when>
			<xsl:otherwise>
				<img src="images/icons/bullet.gif" alt="Selectable Item" class="link"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="processAnnotations">
		<xsl:choose>
			<xsl:when test="n1:property[@name='PropertyMap']/n1:dictionary/n1:entry[@key='hdrPossible']">
				<xsl:text>*</xsl:text>
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="n1:property[@name='PropertyMap']/n1:dictionary/n1:entry[@key='fhiePossible']">
				<xsl:text disable-output-escaping="yes"><![CDATA[&dagger;]]></xsl:text>
			</xsl:when>
			<xsl:when test="n1:property[@name='onePropertyMap' and @value='fhiePossible:']">
				<xsl:text disable-output-escaping="yes"><![CDATA[&dagger;]]></xsl:text>
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="n1:property[@name='PropertyMap']/n1:dictionary/n1:entry[@key='nhinPossible']">
				<xsl:text disable-output-escaping="yes"><![CDATA[&Dagger;]]></xsl:text>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="n1:property[@name='title' or @name='Title']">
		<xsl:choose>
			<xsl:when test="n1:value">
				<xsl:value-of select="n1:value"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="@value"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet> 

